//Code by Laura June 2014
//Starts from BlinkMTesterLP and i2cMaster and stateChangeDetectionLP
//See previous versions for notes on setting up the BlinkMMax networking
//NOTE: used the BlinkTesterLP sketch to change the I2C address of each of the BlinkM's

/////////////////////////////////////////////////////////////////////////////////////

   /////////////////////////////////////////////////////////// POTENTIALLY USEFUL FUNCTIONS
   //Serial.flush()
   //Serial.begin()
   //Serial.end()
   //Serial.peak()
   ////////////////////////////////////////////////////////////


//Function to get the serial port ready to go--other stuff goes here too
void networkingSetup()
{
//  Serial.begin(19200);
  Serial.begin(9600);

}


////////////////////////////////////////////////////////////////////////////////////
//Function that makes arduino wait for data from serial
//Use this after we've sent over new button values and want to hear position values
//http://forum.arduino.cc/index.php/topic,43476.0.html
boolean lineAvailable(int max_line,char *line)
{
      int c;
      static int line_idx = 0;
      boolean eol = false;
      if (max_line <= 0)    // handle bad values for max_line
      {
        eol = true;
        if (max_line == 0)
          line[0] = '\0';
      }
      else                // valid max_line
      {
        if (Serial.available() > 0)
        {
          //to check how much data we're getting--don't use for real
          digitalWrite(7, 1);
          delay(300);
          digitalWrite(7,0);
          delay(300);
          
          c = Serial.read();
          if (c != -1)  // got a char -- should always be true
          {
            if (c == '\r')
              eol = true;
            else
              line[line_idx++] = c;
            if (line_idx >= max_line)
              eol = true;
            line[line_idx] = '\0';     // always terminate line, even if unfinished
            if (eol)
              line_idx = 0;           // reset for next line
            }
          }
        }
        return eol;
}


///////////////////////////////
//Function to pass data from python on to the slaves
//works with light data or motor data
void pythonToSlaves(){
 int data[5];
 //use the generic version of sending
 pythonDataShort(data);
 
 //see which we're supposed to be sending to, and then send it
 int dataType = data[0];
 int deviceVal = data[1];
 int val1 = data[2];
 int val2 = data[3];
 int val3 = data[4];
 
 //if it's motor data; send it to arduino
 if (dataType == 2) {
 int motorTime = val2 * 10 + val3*1;
 arduinoMotorSend(deviceVal, motorTime, val1); 
 }
 //if it's led data, send it to the blink
 else if (dataType ==1) {
   arduinoLEDSendDirect(deviceVal, 1, 1, 1);
   delay(1000);
   //unclear if the blink goes off this function or a different one--check later
  //arduinoLEDSend(arduinoVal, val1, val2, val3); //OLD
  
 
  
  //THIS WORKS!!!  HAVE TO CHANGE THE DATA ACCORDINGLY!!!
  //won't need a if 1 or if 2--they go to different addresses
  //I guess can keep it if easier--maybe useful later
  //change this in the slave too
  
  
  arduinoLEDSendDirect(deviceVal, val1, val2, val3);
  delay(1000);

//arduinoLEDSendDirect(11, 1, 0, 0);

 }
}



///////////////////////////////
//Function to do something with the motors based on the python data
//CHANGE THIS FUNCTION SO IT SENDS THE DATA TO OTHER ARDUINOS (DOESN"T TURN ON MOTOR)
void motorPython(){
//get the data and stick it someplace
int data[6];
pythonData(data);

//Use the motor stuff from it--the second variable is the direction, the third variable is the time (in seconds)
//The first is the arduino number, which we'll need--NEEDS TO BE A BYTE
int arduinoVal = data[0];
int motorTime = data[2] * 1000; //get this from milliseconds to seconds
int motorDirection = data[1];

//if (motorTime>0) Serial.println(motorTime);
//if (motorDirection>0) Serial.println(motorDirection);

//Send these values---FIGURE OUT WHERE TO SWITCH THEIR TYPES 
arduinoMotorSend(arduinoVal, motorTime, motorDirection);

//run the motor based on these variables
//motorBBC(motorTime, motorDirectionToValue(motorDirection));

}



//////////////////////////////////////////////// 
//NOT IN USE!!
//Function to do something with the lights based on the python data
void ledPython(){
  //byte arduino_addr;
 //get the data and put it someplace
 int data[6];
 pythonData(data);
 
 //Get the address that we're sending to
 //UNCLEAR IF THIS IS WORKING
 byte arduinoAddr = (char)data[0];
 
 //Use the LED stuff from it, this is the fourth, fifth, sixth values
 //if it's 0, don't do anything to the LED
 //if it's 1 change it to on
 //if it's 2 change it to off
 
 int redLED= data[3];
 int greenLED = data[4];
 int blueLED = data[5];
 
 if (redLED != 0){
 ledState[0]= intToBoolLed(redLED);
 }

 if (greenLED != 0){
 ledState[1]= intToBoolLed(greenLED);
 }

 if (blueLED != 0){
 ledState[2]= intToBoolLed(blueLED);
 }

 
 Serial.print(ledState[0]);
 Serial.print(ledState[1]);
 Serial.println(ledState[2]);
 
  //Run the function that turns on the lights
  
  arduinoLEDSend(arduinoAddr, ledState[0], ledState[1], ledState[2]);
  //arduinoLEDSendDirect(11, 1, 0, 0);
  
//This happens elsewhere now
//  blinkMMaxSend(ledState[0], ledState[1], ledState[2]);
  
}

//////////////////////////////////////////////////////////
//Function to get python data from serial--the short version (seperates motor and LEDs into individual lines

//function that gets data from python and leaves it in pointer land for reference by other functions
void pythonDataShort(int pdata[]){
  //Here we're getting a 6 digit string from python
  //We want each of the chunks to split up to different variables to do different things
  //parts are: data type (1), arduino ID (2), value 1, value 2, value 3
  //for motors: 2 , ID, ID, motor direction, motor time 1, motor time 2
  //for lights: 1, ID, ID, red, blue, green
  
  //it all comes in already and is stored in line as a string...of length 6
  //take the string apart
  
  char incomingByte;
  unsigned int integerValue=0; 
  int count = 0;

  
  int dataType = 0;
  int arduinoVal = 0;
  int val1 = 0;
  int val2  = 0;
  int val3 = 0;

  //Get the character, then change it from ASCII to integer
  dataType = line[0]-48;
  arduinoVal = (line[1] -48)* 10 + (line[2]-48);
  val1 = line[3]-48;
  val2 = line[4]-48;
  val3 = line[5]-48;

 //Store this in a pointer thing
  pdata[0] = dataType;
  pdata[1] = arduinoVal;
  pdata[2] = val1;
  pdata[3] = val2;
  pdata[4] = val3;
  
  //NOTE: motor time needs to be reassembled elsewhere...do this in the sending function
  
}





/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Function to get all the python data from serial!
//function that gets data from python and leaves it in pointer land for reference by other functions
void pythonData(int pdata[]){
  //Here we're getting a nine digit string from arduino
  //We want each of the chunks to split up to different variables to do different things
  //parts are: arduino ID (2), direction (1), time (3), leds (3)
  
  char incomingByte;
  unsigned int integerValue=0; 
  int count = 0;
  int arduinoVal = 0;
  int motorDirectionVal = 0;
  int motorTimeVal  = 0;
  int ledRedVal = 0;
  int ledGreenVal = 0;
  int ledBlueVal = 0;

  if (Serial.available()> 0) {
  
  //Get the arduino number we're talking to
  while (count < 2){  
      incomingByte = Serial.read();
      if (incomingByte == '\n') break;   // exit the while(1), we're done receiving
      if (incomingByte == -1) continue;  // if no characters are in the buffer read() returns -1
      arduinoVal *= 10;  // shift left 1 decimal place
      // convert ASCII to integer, add, and shift left 1 decimal place
      arduinoVal = ((incomingByte - 48) +arduinoVal);
      //arduinoVal = count;
      count = count +1;
    }
    
  //Get the motor direction
   while (count < 3){
      incomingByte = Serial.read();
      if (incomingByte == '\n') break;   // exit the while(1), we're done receiving
      if (incomingByte == -1) continue;  // if no characters are in the buffer read() returns -1
      motorDirectionVal *= 10;  // shift left 1 decimal place
      // convert ASCII to integer, add, and shift left 1 decimal place
      motorDirectionVal = ((incomingByte - 48) + motorDirectionVal);
      count = count +1;
    }
    
   //Get the motor time 
   while (count < 6){
      incomingByte = Serial.read();
      if (incomingByte == '\n') break;   // exit the while(1), we're done receiving
      if (incomingByte == -1) continue;  // if no characters are in the buffer read() returns -1
      motorTimeVal *= 10;  // shift left 1 decimal place
      // convert ASCII to integer, add, and shift left 1 decimal place
      motorTimeVal = ((incomingByte - 48) + motorTimeVal);
      count = count +1;
    }
    
    //Get the LED digits--seperately three digits--should hit the newline
   while (count < 7){
      incomingByte = Serial.read();
      if (incomingByte == '\n') break;   // exit the while(1), we're done receiving
      if (incomingByte == -1) continue;  // if no characters are in the buffer read() returns -1
      ledRedVal *= 10;  // shift left 1 decimal place
      // convert ASCII to integer, add, and shift left 1 decimal place
      ledRedVal = ((incomingByte - 48) + ledRedVal);
      count = count +1;
    }
       //Get the motor time 
   while (count < 8){
      incomingByte = Serial.read();
      if (incomingByte == '\n') break;   // exit the while(1), we're done receiving
      if (incomingByte == -1) continue;  // if no characters are in the buffer read() returns -1
      ledGreenVal *= 10;  // shift left 1 decimal place
      // convert ASCII to integer, add, and shift left 1 decimal place
      ledGreenVal = ((incomingByte - 48) + ledGreenVal);
      count = count +1;
    }

   while (1) {
      incomingByte = Serial.read();
      if (incomingByte == '\n') break;   // exit the while(1), we're done receiving
      if (incomingByte == -1) continue;  // if no characters are in the buffer read() returns -1
      ledBlueVal *= 10;  // shift left 1 decimal place
      // convert ASCII to integer, add, and shift left 1 decimal place
      ledBlueVal = ((incomingByte - 48) + ledBlueVal);
      count = count +1;
    }

//  if (arduinoVal >0) Serial.println(arduinoVal);
//  if (motorDirectionVal >0) Serial.println(motorDirectionVal);
//  if (motorTimeVal) Serial.println(motorTimeVal);
//  if (ledVal) Serial.println(ledVal);
  }

  pdata[0] = arduinoVal;
  pdata[1] = motorDirectionVal;
  pdata[2] = motorTimeVal;
  pdata[3] = ledRedVal;
  pdata[4] = ledGreenVal;
  pdata[5] = ledBlueVal;
  
  
}


/////////////////////////////////////////////////////////////////////
//function to send the motor data to the arduinos
//Used in motorPython
void arduinoMotorSend(byte arduinoAddr, boolean motorDirection, int motorTime){
  Wire.begin(arduinoAddr);
  Wire.beginTransmission(arduinoAddr);
  //Signal that it's motor data
  Wire.write(2);
  //send the values
  Wire.write(motorDirection); 
  Wire.write(motorTime); 
  Wire.endTransmission();   
}


/////////////////////////////////////////////////////////////////////
//function to send the LED data to the arduinos
//used in ledPython
void arduinoLEDSend(byte arduinoAddr, boolean led1, boolean led2, boolean led3){
  Wire.begin(arduinoAddr);
  Wire.beginTransmission(arduinoAddr);
  //Signal that it's arduino data
  Wire.write(1);
  //send the values
  Wire.write(led1); 
  Wire.write(led2); 
  Wire.write(led3); 
  //Wire.write(1);
 //Wire.write(0);
//Wire.write(0);  
  
  Wire.endTransmission();   
}

/////////////////////////////////////// NEW
//Try to talk to the blink directly!  not through having the arduino send it info
//copied from the BlinkM_setRGB function
void arduinoLEDSendDirect(byte blinkAddr, boolean led1, boolean led2, boolean led3){
  //values times 254
  //not sure about the begin here
  byte red = led1*254;
  byte green = led2*254; 
  byte blue = led3*254;
  Wire.begin(blinkAddr);
//  Wire.begin(0);
  Wire.beginTransmission(blinkAddr);
  //Wire.beginTransmission(0);
  Wire.write('n');
  Wire.write(red);
  Wire.write(green);
  Wire.write(blue);
  Wire.endTransmission();
  delay(500);
  //pinMode(8, OUTPUT);
   //digitalWrite(8,1);
}




//////////////////////////////////
//Function to send values from the arduino back to the computer/python
//NOTE: FIGURE OUT HOW TO MAKE SURE DELAY DOESN'T MESS THINGS UP 
//Used in buttonToPython
void arduinoToPythonSerial(int val) {
    Serial.println(val);
    delay(200);  // we have to make a delay to avoid overloading the serial port
    //NOTE: 100 was too little, python was missing stuff. 200 seems to be okay for sending one thing.
}


//////////////////////////////////
//Function to check the validity of the button values before sending anything to python
//Returns true if we should send (and then wait for a response etc etc) otherwise false
boolean shouldButtonSend(boolean buttonState[]){

  //Make sure they make sense...we can't have multiple chemicals or two times at ones
  //first buttons should sum to one
  if ((buttonState[0]+buttonState[1])!=1){
    return false;
  }
  //second buttons should sum to one
  else if ((buttonState[2]+buttonState[3]+buttonState[4])!=1){
    return false;
  }
  else 
    return true;
}
  


//////////////////////////////////

//Another function to get and send values from the arduino buttons back to the computer/python
//Send back a two digit number: button set 1 (time 1/2) and button set 2 (chemical 1/2/3)
//used in main loop
void buttonToPython(boolean buttonState[]){
  //Read the button values in another function
  //buttonState variable contains the new results, after something has changed
  //We check if the value is legit in the shouldButtonSend function

  //Figure out which is pressed--there is probably a cleaner way to do this
  int whichButton1 = 0;
  int whichButton2 = 0;
  
  //Add more else's here if you want something to send for sure---though first check should take care of this some
  if (buttonState[0]==1){
    whichButton1 = 1;
  }
  else{
    whichButton1 = 2;
  }
  
  
  //Next one
  if (buttonState[2]==1){
    whichButton2 = 1;
  }
  else if (buttonState[3]==1){
    whichButton2 = 2;
  }
  else {
    whichButton2 =3;
  }
  
  //Slap them together
  buttonSend = whichButton1*10 + whichButton2;
  
  //Since this is a new button state, send the values to arduino (a couple times?)
  arduinoToPythonSerial(buttonSend);
  
}


//////////////////////////////////
//Function to tell the other arduino to turn on some lights
void arduinoLight(boolean r, boolean g, boolean b){
  //send a set of three t/f to the arduino telling which lights are on vs off
  Wire.begin(arduino_addr);
  Wire.beginTransmission(arduino_addr);
  Wire.write(0); 
  Wire.write(0); 
  Wire.write(0); 
  //send the actual values
  Wire.write(r); 
  Wire.write(g); 
  Wire.write(b); 
  Wire.endTransmission();
//  Serial.println("sent");
}

//Function for testing if anything is being sent
void arduinoSimple(){
  //send a set of three t/f to the arduino telling which lights are on vs off
  Wire.begin(arduino_addr);
 Serial.println("start send");
  Wire.beginTransmission(arduino_addr);
  Serial.println("sentA");
  Wire.write(0); 
  Serial.println("sentB");
  Wire.endTransmission();
  Serial.println("sentS");
}


